#!/bin/sh

make clean
make

#----------#
k=3     # topic
u=100   # objects
v=1000  # actors
n=100   # duration
#----------#

DAT="dat/"
DIR="./output/"
mkdir $DIR
x_ifn=$DIR"x_i"
x_avg=200 # average number of events per timetick
rm $x_ifn; for (( i=1; i<= $u; i++ )); do  echo $x_avg >> $x_ifn; done

#--- generate samples ---#
if [ 1 == 1 ]; then
  Ofn=$DAT"O"
  Afn=$DAT"A"
  Cfn=$DAT"C"
  outdir=$DIR"tensor/"
  mkdir $outdir
  echo "//-----------------------------------------//"
  echo "//   generate synthetic tensor data"
  echo "//   (preparation for the experiments)"
  echo "//   Given: O, A, C matrices ($DAT)"
  echo "//   Out:   tensor ($outdir) "
  echo "//-----------------------------------------//"
  ./generate -s $Ofn $Afn $Cfn $x_ifn $k $u $v $n $outdir
  dblist=$DIR"list"
  rm $dblist
  for (( i=1; i<=$n; i++ )) 
  do 
    echo $outdir"dat.t"$i >> $dblist 
  done
fi
#------------------------#

outdir=$DIR"model/"
mkdir $outdir
#--- inference ---#
if [ 1 = 1 ]; then
  echo "//-----------------------------------------//"
  echo "//   TriMine: inference "
  echo "//   Given: tensor ($dblist) "
  echo "//   Out:   O, A, C matrices ($outdir) "
  echo "//-----------------------------------------//"
  ./trimine $k $u $v $n $dblist $outdir
fi
#--- forecast C matrix ---#
if [ 1 = 1 ]; then
  echo "//-----------------------------------------//"
  echo "//   Multi-scale forecasting "
  echo "//   Given: C matrix ($outdir) "
  echo "//   Out:   Cf i.e., forecasted C ($outdir) "
  echo "//-----------------------------------------//"
  dat=$outdir"C"
  outfn=$outdir"Cf"
  orderfn=$DAT"orders"
  ./mscaleAR $dat $k $n $n $orderfn $outfn
fi
#--- generate future events ---#
if [ 1 == 1 ]; then
  Ofn=$outdir"O"
  Afn=$outdir"A"
  Cfn=$outdir"Cf"
  foutdir=$DIR"forecast/"
  n2=`expr $n \* 2`
  mkdir $foutdir
  echo "//-----------------------------------------//"
  echo "//   TriMine-F: generate future events "
  echo "//   from O, A, Cf matrices ($outdir)"
  echo "//   Out:   tensor, objectID=1, 3, 5 ($foutdir) "
  echo "//-----------------------------------------//"
  ./generate -e 1 $Ofn $Afn $Cfn $x_ifn $k $u $v $n2 $foutdir
  ./generate -e 3 $Ofn $Afn $Cfn $x_ifn $k $u $v $n2 $foutdir
  ./generate -e 5 $Ofn $Afn $Cfn $x_ifn $k $u $v $n2 $foutdir
  #./generate -a $Ofn $Afn $Cfn $x_ifn $k $u $v $n2 $foutdir
#------------------------#
fi



